searchNodes=[{"ref":"Exjprop.html","title":"Exjprop","type":"module","doc":"Exjprop is a library for reading Java properties files. It includes the Exjprop.Properties protocol and several implementations including File, Stream, Function, and S3. Examples File Example props = Exjprop.Properties.File.new(&quot;/path/to/java.properties&quot;) props = Exjprop.Properties.load some_prop = Exjprop.Properties.get_property!(props, &quot;some.prop&quot;) Stream Example stream = File.stream!(&quot;/path/to/java.properties&quot;) props = Exjprop.Properties.Stream.new(stream) props = Exjprop.Properties.load some_prop = Exjprop.Properties.get_property!(props, &quot;some.prop&quot;) Function Example fun = fn -&gt; File.stream!(&quot;/path/to/java.properties&quot;) end props = Exjprop.Properties.Function.new(fun) props = Exjprop.Properties.load some_prop = Exjprop.Properties.get_property!(props, &quot;some.prop&quot;) S3 Example # using access/secret keys from environment or ec2 identity # metadata service props = Exjprop.Properties.S3.new(&quot;props-bucket&quot;, &quot;java.properties&quot;) props = Exjprop.Properties.load some_prop = Exjprop.Properties.get_property!(props, &quot;some.prop&quot;) # explicitly specifying access/secret keys props = Exjprop.Properties.S3.new( &quot;props-bucket&quot;, &quot;java.properties&quot;, &quot;access&quot;, &quot;secret&quot;) props = Exjprop.Properties.load some_prop = Exjprop.Properties.get_property!(props, &quot;some.prop&quot;)"},{"ref":"Exjprop.Loader.html","title":"Exjprop.Loader","type":"module","doc":""},{"ref":"Exjprop.Loader.html#get_property!/2","title":"Exjprop.Loader.get_property!/2","type":"function","doc":"Get a property"},{"ref":"Exjprop.Loader.html#load_properties/1","title":"Exjprop.Loader.load_properties/1","type":"function","doc":"Load the properties for the given uri/fun/stream"},{"ref":"Exjprop.Loader.html#property/2","title":"Exjprop.Loader.property/2","type":"macro","doc":"Define a property, including it&#39;s source key, and application env destination and options (including a pipeline)"},{"ref":"Exjprop.Loader.html#property/3","title":"Exjprop.Loader.property/3","type":"macro","doc":""},{"ref":"Exjprop.Loader.html#update_env/2","title":"Exjprop.Loader.update_env/2","type":"function","doc":"Given configured props and loaded props, update the application env"},{"ref":"Exjprop.Loader.ValidationError.html","title":"Exjprop.Loader.ValidationError","type":"exception","doc":""},{"ref":"Exjprop.Loader.ValidationError.html#new/4","title":"Exjprop.Loader.ValidationError.new/4","type":"function","doc":""},{"ref":"Exjprop.Parser.html","title":"Exjprop.Parser","type":"module","doc":""},{"ref":"Exjprop.Parser.html#parse/1","title":"Exjprop.Parser.parse/1","type":"function","doc":"Parse an enumerable or multi-line string of properties into a map of keys and values. If an enumerable is given, each enumberable entry should be a single key=value entry."},{"ref":"Exjprop.Properties.html","title":"Exjprop.Properties","type":"protocol","doc":""},{"ref":"Exjprop.Properties.html#get_property/2","title":"Exjprop.Properties.get_property/2","type":"function","doc":""},{"ref":"Exjprop.Properties.html#get_property!/2","title":"Exjprop.Properties.get_property!/2","type":"function","doc":""},{"ref":"Exjprop.Properties.html#load/1","title":"Exjprop.Properties.load/1","type":"function","doc":""},{"ref":"Exjprop.Properties.html#loaded?/1","title":"Exjprop.Properties.loaded?/1","type":"function","doc":""},{"ref":"Exjprop.Properties.html#to_map/1","title":"Exjprop.Properties.to_map/1","type":"function","doc":""},{"ref":"Exjprop.Properties.html#t:t/0","title":"Exjprop.Properties.t/0","type":"type","doc":""},{"ref":"Exjprop.Properties.File.html","title":"Exjprop.Properties.File","type":"module","doc":""},{"ref":"Exjprop.Properties.File.html#get_property/2","title":"Exjprop.Properties.File.get_property/2","type":"function","doc":"Get the value of a property. See Exjprop.Properties.Stream for return values"},{"ref":"Exjprop.Properties.File.html#get_property!/2","title":"Exjprop.Properties.File.get_property!/2","type":"function","doc":"Get the value of a property. Returns nil if the property does not exist. Raises an error if there is a problem fetching the property"},{"ref":"Exjprop.Properties.File.html#load/1","title":"Exjprop.Properties.File.load/1","type":"function","doc":"Load the resource"},{"ref":"Exjprop.Properties.File.html#loaded?/1","title":"Exjprop.Properties.File.loaded?/1","type":"function","doc":"Returns true/false if the properties have been loaded"},{"ref":"Exjprop.Properties.File.html#new/1","title":"Exjprop.Properties.File.new/1","type":"function","doc":"Create a new file properties"},{"ref":"Exjprop.Properties.File.html#to_map/1","title":"Exjprop.Properties.File.to_map/1","type":"function","doc":"Get a map of properties"},{"ref":"Exjprop.Properties.Function.html","title":"Exjprop.Properties.Function","type":"module","doc":""},{"ref":"Exjprop.Properties.Function.html#get_property/2","title":"Exjprop.Properties.Function.get_property/2","type":"function","doc":"Get a property"},{"ref":"Exjprop.Properties.Function.html#get_property!/2","title":"Exjprop.Properties.Function.get_property!/2","type":"function","doc":"Get a property, raising exceptions on error"},{"ref":"Exjprop.Properties.Function.html#load/1","title":"Exjprop.Properties.Function.load/1","type":"function","doc":"Load the properties from the given function"},{"ref":"Exjprop.Properties.Function.html#loaded?/1","title":"Exjprop.Properties.Function.loaded?/1","type":"function","doc":"Determine if the properties have been loaded"},{"ref":"Exjprop.Properties.Function.html#new/1","title":"Exjprop.Properties.Function.new/1","type":"function","doc":"Create new function properties The passed in function must take no arguments and return a Stream"},{"ref":"Exjprop.Properties.Function.html#to_map/1","title":"Exjprop.Properties.Function.to_map/1","type":"function","doc":"Get a map of properties"},{"ref":"Exjprop.Properties.S3.html","title":"Exjprop.Properties.S3","type":"module","doc":""},{"ref":"Exjprop.Properties.S3.html#load/1","title":"Exjprop.Properties.S3.load/1","type":"function","doc":"Load the properties form the remote resource"},{"ref":"Exjprop.Properties.S3.html#loaded?/1","title":"Exjprop.Properties.S3.loaded?/1","type":"function","doc":"Returns true/false if the properties have been loaded"},{"ref":"Exjprop.Properties.S3.html#new/2","title":"Exjprop.Properties.S3.new/2","type":"function","doc":"Create a new remote properties. Access and Secret key will be retrieved from ENV var or Metadata service"},{"ref":"Exjprop.Properties.Stream.html","title":"Exjprop.Properties.Stream","type":"module","doc":""},{"ref":"Exjprop.Properties.Stream.html#get_property/2","title":"Exjprop.Properties.Stream.get_property/2","type":"function","doc":"Returns {:ok, value} where value may be nil if the property is empty or does not exist"},{"ref":"Exjprop.Properties.Stream.html#get_property!/2","title":"Exjprop.Properties.Stream.get_property!/2","type":"function","doc":"Get the value of a property. Returns nil if the property does not exist. Raises a ResourceNotLoadedException if the file has not be loaded yet."},{"ref":"Exjprop.Properties.Stream.html#load/1","title":"Exjprop.Properties.Stream.load/1","type":"function","doc":"Load the resource"},{"ref":"Exjprop.Properties.Stream.html#loaded?/1","title":"Exjprop.Properties.Stream.loaded?/1","type":"function","doc":"Returns true/false if the properties have been loaded"},{"ref":"Exjprop.Properties.Stream.html#new/1","title":"Exjprop.Properties.Stream.new/1","type":"function","doc":"Create a new stream properties"},{"ref":"Exjprop.Properties.Stream.html#to_map/1","title":"Exjprop.Properties.Stream.to_map/1","type":"function","doc":"Get the properties as a map"},{"ref":"Exjprop.Properties.Stream.PropertyRetrievalException.html","title":"Exjprop.Properties.Stream.PropertyRetrievalException","type":"exception","doc":""},{"ref":"Exjprop.Properties.Stream.ResourceNotLoadedException.html","title":"Exjprop.Properties.Stream.ResourceNotLoadedException","type":"exception","doc":""},{"ref":"Exjprop.String.html","title":"Exjprop.String","type":"module","doc":""},{"ref":"Exjprop.String.html#to_stream/1","title":"Exjprop.String.to_stream/1","type":"function","doc":"Convert a string into a Stream"},{"ref":"Exjprop.Validators.html","title":"Exjprop.Validators","type":"module","doc":""},{"ref":"Exjprop.Validators.html#float/1","title":"Exjprop.Validators.float/1","type":"function","doc":"If the property is non-nil, parse it to a float"},{"ref":"Exjprop.Validators.html#integer/1","title":"Exjprop.Validators.integer/1","type":"function","doc":"If the property is non-nil, parse it to an integer"},{"ref":"Exjprop.Validators.html#keyword/1","title":"Exjprop.Validators.keyword/1","type":"function","doc":"If the property is non-nil, parse the given json string to a keyword list. Supports both js objects and lists of js objects."},{"ref":"Exjprop.Validators.html#map/1","title":"Exjprop.Validators.map/1","type":"function","doc":"If the property is non-nil, parse the json string to a map. Supports both js objects and lists of js objects."},{"ref":"Exjprop.Validators.html#required/1","title":"Exjprop.Validators.required/1","type":"function","doc":"Require a property"}]